package hossein;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

public class MakeGragh {
	private String fileName;

	private static final String SEPERATOR = " ";

	private ArrayList bridgeList = new ArrayList();

	private ArrayList lanList = new ArrayList();

	public MakeGragh(String fileName) {
		this.fileName = fileName;

		BufferedReader input = getFileDescriptor();
		StringBuffer buffer = new StringBuffer();
		String text;
		if (input == null) {
			System.out
					.println("****************input file has problem********************");
			return;
		}
		try {
			while ((text = input.readLine()) != null) {
				//				System.out.println("------------>line is " + text);
				lineHandler(text);
			}
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
	}

	public ArrayList getLANS() {
		return getSortedLan();
	}

	public ArrayList getBridges() {
		return getSortedBridge();
	}

	public String getFileName() {
		return fileName;

	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	private BufferedReader getFileDescriptor() {
		File file = new File(fileName);
		if (file.exists() && file.isFile()) {
			try {
				BufferedReader bufferedReader = new BufferedReader(
						new FileReader(file));
				return bufferedReader;
			} catch (FileNotFoundException e) {

				e.printStackTrace(); //To change body of catch statement use
				// File | Settings | File Templates.
				System.out.println("*******************************");
				System.out.println("----->FileNotFoundERROR");
				System.out.println("*******************************");
				return null;
			}
		} else {
			System.out.println("*******************************");
			System.out.println("------->file is not exist or is not file");
			System.out.println("*******************************");
			return null;
		}
	}

	private void lineHandler(String line) {
		StringTokenizer tokenizer = new StringTokenizer(line, SEPERATOR);
		Bridge bridge = findBridge(Integer.parseInt(tokenizer.nextToken()));
		if (bridge == null) {
			System.out.println("*******************************");
			System.out.println("------------> The returned bridged is null");
			System.out.println("*******************************");
		}
		int lanId = 1;
		String lanName = "";
		while (tokenizer.hasMoreTokens()
				&& (lanName = tokenizer.nextToken(SEPERATOR)) != null) {
			lanId = Integer.parseInt(lanName);
			LAN lan = findLan(lanId);
			if (lan == null) {
				System.out.println("*******************************");
				System.out.println("------->The returned lan is null ");
				System.out.println("*******************************");
			}
			lan.addBridge(bridge);
			bridge.addLAN(lan);
		}
	}

	private Bridge findBridge(int id) {
		for (Iterator iterator = bridgeList.iterator(); iterator.hasNext();) {
			Bridge bridge = (Bridge) iterator.next();
			if (bridge.getId() == id) {
				return bridge;
			}
		}
		Bridge newBridge = new Bridge(id);
		bridgeList.add(newBridge);
		return newBridge;
	}

	private LAN findLan(int id) {
		for (Iterator iterator = lanList.iterator(); iterator.hasNext();) {
			LAN lan = (LAN) iterator.next();
			if (lan.getId() == id)
				return lan;
		}
		LAN newLan = new LAN(id);
		lanList.add(newLan);
		return newLan;

	}

	private ArrayList getSortedLan() {
		LAN lans[] = (LAN[]) lanList.toArray(new LAN[lanList.size()]);
		for (int i = 0; i < lans.length; i++) {
			for (int j = 0; j < lans.length; j++) {
				if ((lans[i].getId() < lans[j].getId())) {
					LAN tmp = lans[i];
					lans[i] = lans[j];
					lans[j] = tmp;
				}
			}
		}
		ArrayList sortedLans = new ArrayList();
		for (int i = 0; i < lans.length; i++) {
			sortedLans.add(lans[i]);
		}
		return sortedLans;
	}

	private ArrayList getSortedBridge() {
		Bridge bridges[] = (Bridge[]) bridgeList.toArray(new Bridge[bridgeList
				.size()]);
		for (int i = 0; i < bridges.length; i++) {
			for (int j = 0; j < bridges.length; j++) {
				if (bridges[i].getId() < bridges[j].getId()) {

					Bridge tmp = bridges[i];
					bridges[i] = bridges[j];
					bridges[j] = tmp;
				}
			}
		}
		ArrayList sortedBridge = new ArrayList();
		for (int i = 0; i < bridges.length; i++) {
			sortedBridge.add(bridges[i]);
		}
		return sortedBridge;
	}

}

