package naeem;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import hossein.Bridge;
import hossein.MakeGragh;

public class Simulator {
	static final String fileName = "input.txt";

	Collection bridges;

	Collection LANs;

	ArrayList current;

	ArrayList currentLANs;

	ArrayList next = new ArrayList();

	ArrayList nextLANs = new ArrayList();

	public Simulator() {
	}

	public void run() {
		getGraph();

		if (!bridges.iterator().hasNext() || !LANs.iterator().hasNext()) {
			System.out.println("There must be at least one bridge and one LAN");
			return;
		}

		Bridge root = findRoot();

		root.setVisited();
		next.add(root);
		nextLANs.add(null);

		while (next.size() != 0) {
			transitState();

			while (current.size() != 0) {
				connectNextBridge();
			}
		}
	}

	private void connectNextBridge() {
		Integer connectorLAN = (Integer) currentLANs.remove(0);
		Bridge bridge = (Bridge) current.remove(0);

		NextBridgeLANs nextBridges = new NextBridgeLANs(connectorLAN, bridge);

		//Add the smallest bridgeToMerge to the next and advance its iterator
		FoundBridge minBridge = nextBridges.getMin();

		while (minBridge != null) {
			if (!minBridge.getBridge().isVisited()) {
				minBridge.getBridge().setVisited();
				next.add(minBridge.getBridge());
				nextLANs.add(minBridge.getParentLan());
			}

			minBridge = nextBridges.getMin();
		}
	}

	private void transitState() {
		current = next;
		currentLANs = nextLANs;
		next = new ArrayList();
		nextLANs = new ArrayList();
	}

	private Bridge findRoot() {
		Iterator it = bridges.iterator();
		Bridge root = (Bridge) it.next();

		while (it.hasNext()) {
			Bridge temp = (Bridge) it.next();

			if (temp.getId() < root.getId())
				root = temp;
		}

		return root;
	}

	private void getGraph() {
		MakeGragh graph = new MakeGragh(fileName);

		bridges = graph.getBridges();
		LANs = graph.getLANS();
	}
}